# $Id: define.make,v 1.4 2003/02/24 21:26:29 babolo Exp $

.if defined(VMINOR)
 VERS	= ${VMAJOR}.${VMINOR}
 DISTNM	= ${PKG}-${VERS}
 DATE	!= env LANG= LC_ALL= date +%v | sed -e 's| ||g'
.endif

BINMODE		?= 0555
MANMODE		?= 0444
DATAMODE	?= 0444
OWNER		?= -o root -g wheel
CHOWNER		?= "0:0"
INSTALL_PROGRAM	?= install -c -s ${OWNER} -m ${BINMODE}
INSTALL_SCRIPT	?= install -C ${OWNER} -m ${BINMODE}
INSTALL_DATA	?= install -C ${OWNER} -m ${DATAMODE}
INSTALL_MAN	?= install -C ${OWNER} -m ${MANMODE}
PREFIX		?= /usr/local
BINDIR		?= ${PREFIX}/bin
CONFDIR		?= ${PREFIX}/etc
MAN1DIR		?= ${PREFIX}/man/${MANLANG}/man1
LIBEDIR		?= ${PREFIX}/lib/postgresql
LIBINCLUDEDIR	?= ${LIBEDIR}/include
BUILDINCLUDEDIR	?= ${LIBEDIR}/include
WWWROOT		?= ${PREFIX}/www
WWWROOTDATA	?= ${WWWROOT}/ispms
POSTGRESRC	?= ${MAKEOBJDIRPREFIX}/usr/ports/databases/postgresql72/work/postgresql-7.2.4
CP		?= cp
RM		?= rm
SH		?= sh
LN		?= ln
M4		?= gm4
CAT		?= cat
SED		?= sed
AWK		?= awk
PLUSENV		?= env
TAR		?= tar
PWD		?= pwd
GZIP		?= gzip
MAKE		?= make
GREP		?= grep
ECHO		?= echo
MKDIR		?= mkdir
CHOWN		?= chown
CHMOD		?= chmod
TOOLS		?= tools
EXECTMPL	?= ${PLUSENV} ECHO=${ECHO} CAT=${CAT} SED=${SED} GREP=${GREP} SH=${SH} ${SH} -e

CFLAGS		+= ${CFLAGSPLUS} -DVERS=\"${VERS}\" -DDATE=\"${DATE}\"
MAKEFLAGS	+= -I ${BUILDINCLUDEDIR} BUILDINCLUDEDIR=${BUILDINCLUDEDIR}

PLUGSQLSCRIPTS	= S_create S_init S_restore S_tune S_dump S_delete
CLEAN		+= ${PLUGSQLSCRIPTS} ${SGEN}
SCRIPTS		+= ${SGEN}
MISC		+= Makefile

.if defined(PROG)
. if !defined(SRCS)
.  for I in ${PROG}
    SRCS	+= ${I}.c
.  endfor
. endif
. if !defined(MANS)
.  for I in ${PROG}
    MANS	+= ${I}.1
.  endfor
. endif
. if !defined(MANZ)
.  for I in ${MANS}
    MANZ	+= ${I}.gz
.  endfor
. endif
.endif

.for I in ${CSRC}
 SRCS	+= ${I}.c
 OBJS	+= ${I}.o
.endfor

.for I in ${PROG}
 OBJS	+= ${I}.o
.endfor

.MAIN: all
.SUFFIXES : .sql .4tml .html .shtml .so .so.${MAJOR}

